#!/usr/bin/env python3
""" Data Structures and Algorithms for CL 3, Assignment 0
    See <https://https://dsacl3-2023.github.io/a0/> for detailed
    instructions.

    <Please insert your name and the honor code here.>
"""

import argparse


def guess_hangman(template, lexicon, guessed):
    """Given the template, lexicon and guesses so far, guess a letter.

    We try to implement a simple, heuristic-based hangman guesser.
    The idea is to match the most likely word in the lexicon by
    looking at the length of the word, the letters that have already
    been guessed and their position in the template.  In case the word
    is not in the lexicon, guess the most frequent letter in the
    lexicon that we did not guess so far.

    Parameters:
    ----
    template: a sequence, either including a real letter, or
              '_' for unknown letters. Like "h_ngm_n".
    lexicon: an iterable containing words in the known lexicon.
    guessed: a list of letters we guessed so far (we trust the
             caller not to cheat to keep this function stateless & simple)

    Returns: a single unicode character which is the best guess
             according to our heuristic guesser.
    """

    # TODO: Exercise 0.1
    pass


if __name__ == "__main__":
    # Example usage:

    ap = argparse.ArgumentParser()
    ap.add_argument('word')
    ap.add_argument('--lexicon', '-l', default='lexicon.txt')
    ap.add_argument('--max-guesses', '-g', type=int, default=0)
    args = ap.parse_args()

    # read the lexicon from the file give in the argument
    lexicon = set()
    with open(args.lexicon, 'rt') as f:
        for line in f:
            lexicon.add(line.strip())

    # create the empty template for the word
    template = ['_'] * len(args.word)  # a list, since strings are immutable
    guessed = set()
    n = 0 # number of guesses so far

    # Run until template is the same as the word
    # (note that this may loop infinitely if the guess_hangman()
    #  implementation is not correct)
    while ''.join(template) != args.word:
        # Hang if exceeded guesses
        if args.max_guesses and n >= args.max_guesses:
            print(f"Hanged after {n} guesses!")
            exit(0)

        n += 1
        ch = guess_hangman(template, lexicon, guessed)
        guessed.add(ch)

        # Get all the indices that need to be changed to the guessed character
        matches = [i for i, x in enumerate(args.word) if x == ch]

        for i in matches:
            template[i] = ch
        print(ch, ''.join(template))
    print(f"Found in {n} guesses.")
